Index: cpukit/headers.am
===================================================================
--- cpukit/headers.am	(revision 78bbe5940b385269de8282e0224c25d020478bc1)
+++ cpukit/headers.am	(revision 257cf743a5c69f9dd302fe31d99978f84970ad64)
@@ -224,4 +224,5 @@
 include_rtems_rfs_HEADERS += include/rtems/rfs/rtems-rfs-trace.h
 include_rtems_rtems_HEADERS += include/rtems/rtems/asr.h
+include_rtems_rtems_HEADERS += include/rtems/rtems/asrdata.h
 include_rtems_rtems_HEADERS += include/rtems/rtems/asrimpl.h
 include_rtems_rtems_HEADERS += include/rtems/rtems/attr.h
Index: cpukit/include/rtems/rtems/asr.h
===================================================================
--- cpukit/include/rtems/rtems/asr.h	(revision 78bbe5940b385269de8282e0224c25d020478bc1)
+++ cpukit/include/rtems/rtems/asr.h	(revision 257cf743a5c69f9dd302fe31d99978f84970ad64)
@@ -57,23 +57,4 @@
                  rtems_signal_set
              );
-
-/**
- *  The following defines the control structure used to manage
- *  signals.  Each thread has a copy of this record.
- */
-typedef struct {
-  /** This field indicates if are ASRs enabled currently. */
-  bool              is_enabled;
-  /** This field indicates if address of the signal handler function. */
-  rtems_asr_entry   handler;
-  /** This field indicates if the task mode the signal will run with. */
-  Modes_Control     mode_set;
-  /** This field indicates the signal set that is posted. */
-  rtems_signal_set  signals_posted;
-  /** This field indicates the signal set that is pending. */
-  rtems_signal_set  signals_pending;
-  /** This field indicates if nest level of signals being processed */
-  uint32_t          nest_level;
-}   ASR_Information;
 
 /*
Index: cpukit/include/rtems/rtems/asrdata.h
===================================================================
--- cpukit/include/rtems/rtems/asrdata.h	(revision 257cf743a5c69f9dd302fe31d99978f84970ad64)
+++ cpukit/include/rtems/rtems/asrdata.h	(revision 257cf743a5c69f9dd302fe31d99978f84970ad64)
@@ -0,0 +1,58 @@
+/**
+ * @file
+ *
+ * @ingroup ClassicASRImpl
+ *
+ * @brief Classic ASR Data Structures
+ */
+
+/* COPYRIGHT (c) 1989-2013.
+ * On-Line Applications Research Corporation (OAR).
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.org/license/LICENSE.
+ */
+
+#ifndef _RTEMS_RTEMS_ASRDATA_H
+#define _RTEMS_RTEMS_ASRDATA_H
+
+#include <rtems/rtems/asr.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/**
+ * @addtogroup ClassicASRImpl
+ *
+ * @{
+ */
+
+/**
+ *  The following defines the control structure used to manage
+ *  signals.  Each thread has a copy of this record.
+ */
+typedef struct {
+  /** This field indicates if are ASRs enabled currently. */
+  bool              is_enabled;
+  /** This field indicates if address of the signal handler function. */
+  rtems_asr_entry   handler;
+  /** This field indicates if the task mode the signal will run with. */
+  Modes_Control     mode_set;
+  /** This field indicates the signal set that is posted. */
+  rtems_signal_set  signals_posted;
+  /** This field indicates the signal set that is pending. */
+  rtems_signal_set  signals_pending;
+  /** This field indicates if nest level of signals being processed */
+  uint32_t          nest_level;
+}   ASR_Information;
+
+/** @} */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+/* end of include file */
Index: cpukit/include/rtems/rtems/asrimpl.h
===================================================================
--- cpukit/include/rtems/rtems/asrimpl.h	(revision 78bbe5940b385269de8282e0224c25d020478bc1)
+++ cpukit/include/rtems/rtems/asrimpl.h	(revision 257cf743a5c69f9dd302fe31d99978f84970ad64)
@@ -18,5 +18,5 @@
 #define _RTEMS_RTEMS_ASRIMPL_H
 
-#include <rtems/rtems/asr.h>
+#include <rtems/rtems/asrdata.h>
 
 #include <string.h>
Index: cpukit/include/rtems/rtems/tasks.h
===================================================================
--- cpukit/include/rtems/rtems/tasks.h	(revision 78bbe5940b385269de8282e0224c25d020478bc1)
+++ cpukit/include/rtems/rtems/tasks.h	(revision 257cf743a5c69f9dd302fe31d99978f84970ad64)
@@ -43,5 +43,5 @@
 #include <rtems/rtems/types.h>
 #include <rtems/rtems/event.h>
-#include <rtems/rtems/asr.h>
+#include <rtems/rtems/asrdata.h>
 #include <rtems/rtems/attr.h>
 #include <rtems/rtems/status.h>
